; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     80x87 Exp() Function                            *
; *                                                     *
; *     Copyright (C) 2001-2002 Norbert Juffa           *
; *     Copyright (C) 2001-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   F87HEXP

             INCLUDE SE.ASM

             .386
             .387

DATA         SEGMENT WORD PUBLIC USE16

; Externals

             EXTRN   ln2_hi: QWORD
             EXTRN   ln2_lo: QWORD

DATA         ENDS

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE,DS:DATA

; Publics

             PUBLIC  FExp

; Exp function
;
; exp(x) = 2^(x * log2(e))
;
; most accurate version: result good to extended precision
; when prec control is extended precision (as is in TP/BP)
; IN: ST(0) = x  OUT: ST(0) = exp(x)

FExp         PROC    FAR

        if Emul87
             int     3eh
             dw      scExp
        else
                               ; x
             fldl2e            ; log2(e) x
             fmul    st, st(1) ; z = x * log2(e) x
             frndint           ; int(z) x
             fld     ln2_hi    ; ln2_hi int(z) x
             fmul    st, st(1) ; int(z)*ln2_hi int(z) x
             fsubp   st(2), st ; int(z) x-int(z)*ln2_hi
             fld     ln2_lo    ; ln2_lo int(z) x-int(z)*ln2_hi
             fmul    st, st(1) ; int(z)*ln2_lo int(z) x-int(z)*ln2_hi
             fsubp   st(2), st ; int(z) (x-int(z)*ln2_hi)-int(z)*ln2_lo
             fxch    st(1)     ; (x-int(z)*ln2_hi)-int(z)*ln2_lo int(z)
             fldl2e            ; log2(e) (x-int(z)*ln2_hi)-int(z)*ln2_lo int(z)
             fmulp   st(1), st ; frac(z) int(z)
             f2xm1             ; 2^frac(z)-1 int(z)
             fld1              ; 1 2^frac(z)-1 int(z)
             faddp   st(1), st ; 2^frac(z) int(z)
             fscale            ; 2^z int(z)
             fstp    st(1)     ; 2^z = e^x
        endif

             ret

FExp         ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END

comment ~

; fastest version: result good to double prec when
; prec control is extended precision (as is in TP/BP)
; IN: ST(0) = x  OUT: ST(0) = exp(x)

                                        ; x
             fldl2e                     ; log2(e) x
             fmul    st, st(1)          ; z = x * log2(e) x
             fst     st(1)              ; z z
             frndint                    ; int(z) z
             fxch    st(1)              ; z int(z)
             fsub    st, st(1)          ; frac(z) int(z)
             f2xm1                      ; 2^frac(z)-1 int(z)
             fld1                       ; 1 2^frac(z)-1 int(z)
             faddp   st(1), st          ; 2^frac(z) int(z)
             fscale                     ; 2^z int(z)
             fstp    st(1)              ; 2^z
~