; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     80x87 Truncate Routine                          *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2001-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   F87HTRC

             INCLUDE SE.ASM

             .386
             .387

        if Emul87
             EMUL
        else
             NOEMUL
        endif

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  FTrunc

;-------------------------------------------------------------------------------
; FTrunc respresents the TRUNC standard function for code compiled in the {$N+}
; state. If the result of the operation overflows the LONGINT format, an
; overflow exception is signaled.
;
; On entry:  ST(0)   number
;
; On exit:   DX:AX   trunc (number)
;            OE      set, if result overflows LONGINT format
;            ST=ST+1
;
; DESTROYS:  EAX, BX, EDX, Flags
;-------------------------------------------------------------------------------

FTrunc       PROC    FAR

             push    bp
             mov     bp, sp
             sub     sp, 6

        if Emul87
             fstcw   [bp - 6]          ; save current FPU control word
        else
             fnstcw  [bp - 6]          ; save current FPU control word
        endif

             fldcw   CWChop            ; set rounding mode to CHOP
             fistp   dword ptr [bp - 4]; store TOS register to LONGINT variable
             fldcw   [bp - 6]

             mov     ax, [bp - 4]
             mov     dx, [bp - 2]
             mov     sp, bp
             pop     bp
             ret

FTrunc       ENDP

; Chop rounding control word

CWChop       dw      1f3fh

             INCLUDE ALIGN.ASM

CODE         ENDS

             END