; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Longint Multiplication / Squaring               *
; *                                                     *
; *     Copyright (C) 1989-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   LONGMUL

             INCLUDE SE.ASM

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  LongMul

         IF VER60
             PUBLIC  LongSqr
         ENDIF

;-------------------------------------------------------------------------------
; LongSqr computes the square of its argument, a LONGINT value. No check is made
; to assert that the result does not overflow the LONGINT format. This routine
; exits through the LongMul routine.
;
; INPUT:     DX:AX      argument
;
; OUTPUT:    DX:AX      square of argument, if no overflow
;
; DESTROYS:  EAX,EBX,CX,EDX,Flags
;-------------------------------------------------------------------------------

         IF VER60
LongSqr      PROC    FAR

             mov     cx, ax            ; make multiplicand
             mov     bx, dx            ;  same as multiplicator

LongSqr      ENDP
         ENDIF

;-------------------------------------------------------------------------------
; LongMul computes the product of its arguments, two LONGINT values. No check
; is made if the result overflows the LONGINT format.
;
; INPUT:     DX:AX      multiplicand
;            BX:CX      multiplicator
;
; OUTPUT:    DX:AX      product of multiplicand & multiplicator, if no overflow
;
; DESTROYS:  EAX,EBX,EDX,Flags
;-------------------------------------------------------------------------------

LongMul      PROC    FAR

             shl     edx, 16           ; make room for LSW multiplicand
             shl     ebx, 16           ; make room for LSW multiplicator
             mov     dx, ax            ; add MSW multiplicand
             mov     bx, cx            ; add LSW multiplicator
             imul    edx, ebx          ; perform multiplication
             mov     eax, edx          ; put LSW (and whole result) in AX
             shr     edx, 16           ; shift MSW to DX
             ret

LongMul      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END