; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Block Move Routine                              *
; *                                                     *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *     Aligned blockmoves shamelessly adapted from     *
; *     Paul Hsieh's code on                            *
; *     <http://www.pobox.com/~qed/blockcopy.html>      *
; *                                                     *
; *******************************************************

             TITLE   MEMHMOV

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  MoveMem

; Move standard procedure

MoveMem      PROC    FAR

             mov     bx, sp            ; framepointer to access parameters
             mov     dx, ds            ; save TURBO-Pascal data segment
             lds     si, ss:[bx + 10]  ; source
             les     di, ss:[bx + 6]   ; destination
             movzx   ecx, word ptr ss:[bx + 4] ; counter
             mov     eax, ecx

; *******************************************************
; * 16-bit test, doesn't really take into account that  *
; * values of DS & ES may very well prevent overlap     *
; *******************************************************
             cmp     si, di
             jae     no_overlap        ; source >= destination

             std
             add     si, cx            ; end of source + 1
             add     di, cx            ; end of destination + 1
             sub     cx, di
             sub     cx, ax
             neg     cx
             and     cx, 3

             dec     si                ; last byte of source
             dec     di                ; last byte of destination

             sub     eax, ecx
             jle     end_move

             rep     movsb

             sub     si, 3
             sub     di, 3             ; align on dword

             mov     cx, ax
             and     ax, 3
             shr     cx, 2
             rep     movsd

             add     si, 3             ; add for last movsb
             add     di, 3
             jmp     end_move

no_overlap:  cld
             sub     cx, di
             sub     cx, ax
             and     cx, 3
             sub     eax, ecx
             jle     end_move

             rep     movsb
             mov     cx, ax
             and     ax, 3
             shr     cx, 2
             rep     movsd

end_move:    add     cx, ax
             rep     movsb

             mov     ds, dx            ; restore TURBO-Pascal framepointer

             cld                       ; autoincrement!!!!!
             ret     10                ; pop parameters and return

MoveMem      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END