; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Add Component to Set Routine                    *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE SETHADC

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZAddComp

;-------------------------------------------------------------------------------
; ZAddComp adds a single element to the set in the buffer. Since each element in
; a set is represented by a bit, this is simply a matter of setting a bit on in
; a specific byte. The byte offset and the bit within this byte can be computed
; from the number of the element, which is in the range 0..255.
;
; On entry:  [SP+4]  Number of element
;            [SP+6]  Pointer to set buffer
;
; On exit:   [SP]    Pointer to set buffer
;-------------------------------------------------------------------------------

ZAddComp     PROC    FAR

             mov     bx, sp              ; make new frame pointer
             les     di, ss:[bx + 6]     ; pointer to set buffer
             movzx   cx, byte ptr ss:[bx + 4] ; number of element to add
             bts     es:[di], cx
             ret     2                   ; leave destination pointer on stack

ZAddComp     ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END