; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Equality Test Routine                       *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHEQU

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZEqual

;-------------------------------------------------------------------------------
; ZEqual implements the set operators '=' and '<>', which check if two sets are
; equal or not equal, respectively. The sets to be compared are both contained
; in a 32-byte set buffer, which can be compared with a string instruction.
;
; On entry:  [SP+4]  Pointer to first set
;            [SP+8]  Pointer to second set
;
; On exit:   ZF      1, if first set equals second set
;-------------------------------------------------------------------------------

ZEqual       PROC    FAR

             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             les     di, ss:[bx + 8]   ; pointer to first set buffer
             lds     si, ss:[bx + 4]   ; pointer to second set buffer
             mov     cx, 8             ; buffers consist of 8 dwords each

@@1:         add     di, 4
             add     si, 4
             mov     eax, es:[di - 4]
             cmp     eax, ds:[si - 4]
             jne     @@2

             dec     cx
             jnz     @@1

@@2:         mov     ds, dx            ; restore TURBO data segment
             ret     8                 ; pop all parameters and return

ZEqual       ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END