; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Set Union Routine                               *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   SETHUNIT

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  ZUnion

;-------------------------------------------------------------------------------
; ZUnion implements the standard set operator '+'. It creates the union of two
; sets, each of which is contained in a 32-byte set buffer. The resulting set
; contains all elements that are either members of the first set or menbers of
; the second set. This can be implemented as a bitwise OR of the two sets. The
; resulting set overwrites one of the two original sets.
;
; On entry:  [SP+4]  Pointer to first set buffer (= source)
;            [SP+8]  Pointer to second set buffer (= destination)
;
; On exit:   [SP]    Pointer to output set buffer
;-------------------------------------------------------------------------------

ZUnion       PROC    FAR

             mov     bx, sp            ; make new frame pointer
             mov     dx, ds            ; save TURBO data segment
             les     di, ss:[bx + 8]   ; pointer to destination set buffer
             lds     si, ss:[bx + 4]   ; pointer to source set buffer
             mov     cx, 8             ; buffers contain 8 dwords data

@@1:         mov     eax, [si]         ; load a dword from the source set
             add     si, 4
             or      es:[di], eax      ; or it with dword of dest
             add     di, 4
             dec     cx
             jnz     @@1               ; loop until all 8 dwords ORed

             mov     ds, dx            ; restore TURBO data segment
             ret     4                 ; leave destination pointer on stack

ZUnion       ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END