; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     String Compare                                  *
; *                                                     *
; *     Copyright (C) 1990-1993 Norbert Juffa           *
; *     Copyright (C) 2002-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   STRHCMP

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  SCompare

;-------------------------------------------------------------------------------
; SCompare compares two strings and sets the zero and carry flag according to
; the result of the comparison. These flag are set as if two unsigned integers
; had been compared. The routine compares all the characters of the shorter
; string to the ones of the longer string, starting at index 1 in each string.
; The first mismatch determines the result of the comparison. If the characters
; compared are all equal, the string's length is compared: The longer string is
; bigger.
;
; On entry:  [SP+4]  Address of destination string
;            [SP+8]  Address of source string
;
; On exit:   ZF = 1  if Source = Destination
;            CF = 1  if Source < Destination
;-------------------------------------------------------------------------------

SCompare     PROC    FAR

             cld                       ; auto increment for string instructions
             mov     dx, ds            ; save callers data segment
             mov     bx, sp            ; make new frame pointer
             lds     si, ss:[bx + 8]   ; pointer to source
             les     di, ss:[bx + 4]   ; pointer to destination
             mov     al, [si]          ; length source
             inc     si                ; SI ptr to 1st char of source
             mov     bl, es:[di]       ; length destination
             mov     cl, al            ; duplicate length source
             inc     di                ; DI ptr to 1st char of destination
             sub     cl, bl            ; length source - length destination
             sbb     ah, ah            ; AH = FF if length source < length dest.
             and     cl, ah            ; CL = 0, if length source >= length dest
             add     cl, bl            ; CL = Min (length source, length dest)
             xor     ch, ch            ; zero-extend to word, set ZF = 1
             repe    cmpsb             ; comp. strings char by char until diff.
             jne     @@1               ; strings differ

             cmp     al, bl            ; strings equal, compare string length

@@1:         mov     ds, dx            ; restore caller's data segment
             ret     8                 ; pop parameters and return

SCompare     ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END