; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     String Copy Routine                             *
; *                                                     *
; *     Copyright (C) 1990-1993 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   STRHCPY

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  SCopy

;-------------------------------------------------------------------------------
; Copy standard function: Copy (VAR S: STRING; Index, Count: INTEGER): STRING
;
; Copy copies Count characters from S, starting at position Index to a 256 byte
; temporary string buffer. If there are less than Count characters in S after
; Index, the routine copies all the characters from Index to the end of S (note
; that this number can be zero).
;
; On entry:  [SP+4]  Count
;            [SP+6]  Index
;            [SP+8]  Address of source string S
;            [SP+12] Address of destination string
;
; On exit:   [SP]    Address of destination string
;-------------------------------------------------------------------------------

SCopy        PROC    FAR

             cld                       ; auto increment for string instructions
             push    ds                ; save caller's data segment
             mov     bx, sp            ; make new frame pointer
             les     di, ss:[bx + 14]  ; load pointer to destination
             lds     si, ss:[bx + 10]  ; load pointer to source
             mov     ax, ss:[bx + 6]   ; get copy count
             mov     bx, ss:[bx + 8]   ; get index
             cwd                       ; DX = FFFF if count negative, else DX=0
             not     dx                ; DX = FFFF if count positive, else DX=0
             dec     bx                ; index - 1
             and     ax, dx            ; Max (count, 0)
             cmp     bh, 80h           ; index-1 < 0 ?
             sbb     dx, dx            ; DX = FFFF if index-1 pos., else DX = 0
             and     bx, dx            ; Max (index-1, 0)
             movzx   cx, byte ptr [si] ; zero-extended source length
             inc     si                ; pointer to 1st char of source
             sub     bx, cx            ; index - 1 - length
             sbb     dx, dx            ; DX=0, if index-1 > length, else DX=FFFF
             and     bx, dx            ; - max # of chars that could be copied
             neg     bx                ; maxcount
             sub     ax, bx            ; count - maxcount
             sbb     dx, dx            ; DX=0, if count > maxcount, else DX=FFFF
             sub     cx, bx            ; CX = Min (Index-1, Length)
             and     ax, dx            ; count - maxcount = 0, if count>maxcount
             add     si, cx            ; pointer to first char to copy
             add     ax, bx            ; AX = Min (Count, MaxCount)
             stosb                     ; store length of result
             mov     cx, ax            ; need it in CX for string instruction
             shr     cx, 1             ; number of chars odd ?
             jnc     @@1               ; no, even

             movsb                     ; move single char

@@1:         rep     movsw             ; copy chars two at a time
             pop     ds                ; restore caller's data segment
             ret     8                 ; leave destination pointer on stack

SCopy        ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END