; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     String Deletion                                 *
; *                                                     *
; *     Copyright (C) 1990-1993 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   STRHDEL

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  SDelete

;-------------------------------------------------------------------------------
; Delete standard procedure: Delete (VAR S: STRING; Index, Count: INTEGER);
;
; Delete deletes Count characters in S, beginning at position Index. The
; algorithm determines if the characters are effectively deleted from the end
; of the string, in which case it simply sets the string length to Index-1. If
; characters are to be deleted from somewhere in the middle of the string, it
; calculates the number of characters in the string after the last deleted one
; and copies these characters to position Index, decrementing the string length
; by Count.
;
; On entry:  [SP+4]  Count
;            [SP+6]  Index
;            [SP+8]  Pointer to S
;-------------------------------------------------------------------------------

SDelete      PROC    FAR

             push    ds                ; save TURBO-Pascal data segment
             mov     bx, sp            ; make new framepointer
             mov     cx, ss:[bx + 6]   ; CX = count
             mov     ax, ss:[bx + 8]   ; AX = index
             dec     ax                ; index - 1
             cwd                       ; DX = FFFFh if AX < 0 (else DX = 0)
             and     dx, ax            ; index ( else 0)
             sub     ax, dx            ; 0 (else index) = new index
             add     dx, cx            ; index + count (else count) = new count
             jle     $end_del          ; exit, if new count <= 0

             lds     si, ss:[bx + 10]  ; address of string
             movzx   cx, byte ptr [si] ; length of string
             sub     cx, ax            ; length - index + 1
             jle     $end_del          ; exit, if <= 0,

             sub     cx, dx            ; length-count-index+1 = # chars to move
             jg      $continue         ; continue, if # of chars > 0

             mov     [si], al          ; new length = index - 1
             jmp     $end_del          ; done

$continue:   cld                       ; auto-increment
             mov     di, ds            ; let both segment register
             mov     es, di            ;  hold segment of string
             sub     [si], dl          ; new length = length - deleted chars
             add     si, ax            ; char at index
             inc     si                ;  becomes destination
             mov     di, si            ;   of move
             add     si, dx            ; char behind the last that will be del.
             shr     cx, 1             ; number of chars to move odd ?
             jnc     $even_del         ; no

             movsb                     ; yes, move single char

$even_del:   rep     movsw             ; move the rest

$end_del:    pop     ds                ; restore TURBO-Pascal data segment
             ret     8                 ; return and pop parameters

SDelete      ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END